package betterwithmods.module.gameplay.miniblocks;

import betterwithmods.module.gameplay.miniblocks.blocks.BlockMini;
import betterwithmods.module.gameplay.miniblocks.tiles.TileMini;
import net.minecraft.advancements.CriteriaTriggers;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.server.MinecraftServer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.translation.I18n;
import net.minecraft.world.World;

public class ItemMini extends ItemBlock {

    public ItemMini(Block block) {
        super(block);
    }

    public static IBlockState getState(ItemStack stack) {
        if (stack != null && stack.func_77973_b() instanceof ItemMini) {
            NBTTagCompound tag = stack.func_179543_a("texture");
            if (tag != null) {
                return NBTUtil.func_190008_d(tag);
            }
        }
        return null;
    }

    public static boolean matches(ItemStack a, ItemStack b) {
        if((a == null || b == null))
            return false;
        if (!(a.func_77973_b() instanceof ItemMini && b.func_77973_b() instanceof ItemMini))
            return false;

        ItemMini miniA = (ItemMini) a.func_77973_b(), miniB = (ItemMini) b.func_77973_b();
        if (miniA.func_179223_d() != miniB.func_179223_d())
            return false;
        IBlockState stateA = getState(a), stateB = getState(b);
        return stateA != null & stateB != null && stateA.equals(stateB);
    }

    private void setNBT(World worldIn, BlockPos pos, ItemStack stackIn) {
        MinecraftServer minecraftserver = worldIn.func_73046_m();
        if (minecraftserver == null)
            return;

        NBTTagCompound data = stackIn.func_179543_a("miniblock");

        if (data != null) {
            TileEntity tileentity = worldIn.func_175625_s(pos);

            if (tileentity instanceof TileMini) {
                if (!worldIn.field_72995_K && tileentity.func_183000_F()) {
                    return;
                }

                NBTTagCompound tileNBT = tileentity.func_189515_b(new NBTTagCompound());
                NBTTagCompound newNBT = tileNBT.func_74737_b();
                tileNBT.func_179237_a(data);

                if (!tileNBT.equals(newNBT)) {
                    tileentity.func_145839_a(tileNBT);
                    tileentity.func_70296_d();
                }
            }
        }
    }

    public boolean placeBlockAt(ItemStack stack, EntityPlayer player, World world, BlockPos pos, EnumFacing side, float hitX, float hitY, float hitZ, IBlockState newState) {
        if (!world.func_180501_a(pos, newState, 11)) return false;

        IBlockState state = world.func_180495_p(pos);
        if (state.func_177230_c() == this.field_150939_a) {


            func_179224_a(world, player, pos, stack);
            setNBT(world, pos, stack);
            ((BlockMini) this.field_150939_a).onBlockPlacedBy(world, pos, state, player, stack, side, hitX, hitY, hitZ);
            if (player instanceof EntityPlayerMP)
                CriteriaTriggers.field_193137_x.func_193173_a((EntityPlayerMP) player, pos, stack);
        }

        return true;
    }

    @Override
    public String func_77653_i(ItemStack stack) {
        NBTTagCompound tag = stack.func_179543_a("texture");
        String type = "bwm.unknown_mini";
        if (tag != null) {
            IBlockState state = NBTUtil.func_190008_d(tag);
            ItemStack block = new ItemStack(state.func_177230_c(), 1, state.func_177230_c().func_176201_c(state));
            type = block.func_77977_a();
        }
        return String.format("%s %s", I18n.func_74838_a(type + ".name").trim(), I18n.func_74838_a(this.func_77657_g(stack) + ".name").trim());
    }
}
